/*
    -- MAGMA (version 1.4.0-beta1) --
       Univ. of Tennessee, Knoxville
       Univ. of California, Berkeley
       Univ. of Colorado, Denver
       June 2013

       @generated c Thu Jun 20 13:06:53 2013
*/

#ifndef MAGMA_CBULGE_H
#define MAGMA_CBULGE_H

#define PRECISION_c

#ifdef __cplusplus
extern "C" {
#endif

magma_int_t magma_chetrd_he2hb(
    char uplo, magma_int_t n, magma_int_t NB,
    magmaFloatComplex *a, magma_int_t lda,
    magmaFloatComplex *tau, magmaFloatComplex *work, magma_int_t lwork,
    magmaFloatComplex *dT, magma_int_t threads,
    magma_int_t *info);

magma_int_t magma_chetrd_hb2st(
    magma_int_t threads, char uplo, magma_int_t n, magma_int_t nb, magma_int_t Vblksiz,
    magmaFloatComplex *A, magma_int_t lda,
    float *D, float *E,
    magmaFloatComplex *V, magma_int_t ldv,
    magmaFloatComplex *TAU, magma_int_t compT,
    magmaFloatComplex *T, magma_int_t ldt);

magma_int_t magma_cbulge_back(
    magma_int_t threads, char uplo, magma_int_t n, magma_int_t nb, magma_int_t ne, magma_int_t Vblksiz,
    magmaFloatComplex *Z, magma_int_t ldz,
    magmaFloatComplex *dZ, magma_int_t lddz,
    magmaFloatComplex *V, magma_int_t ldv,
    magmaFloatComplex *TAU,
    magmaFloatComplex *T, magma_int_t ldt,
    magma_int_t* info);

magma_int_t magma_cunmqr_gpu_2stages(
    char side, char trans, magma_int_t m, magma_int_t n, magma_int_t k,
    magmaFloatComplex *dA, magma_int_t ldda,
    magmaFloatComplex *dC, magma_int_t lddc,
    magmaFloatComplex *dT, magma_int_t nb,
    magma_int_t *info);

magma_int_t magma_cbulge_get_lq2(magma_int_t n);

magma_int_t magma_cbulge_get_Vblksiz(magma_int_t n, magma_int_t nb);

#ifdef __cplusplus
}
#endif

#endif /* MAGMA_CBULGE_H */
